// --------------------------------------------------------------------------
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// --------------------------------------------------------------------------

import AzureCore
import Foundation
// swiftlint:disable superfluous_disable_command
// swiftlint:disable identifier_name
// swiftlint:disable line_length
// swiftlint:disable cyclomatic_complexity

/// Participants to be added to the thread.
public struct AddChatParticipantsRequest: Codable, Equatable {
    // MARK: Properties

    /// Participants to add to a chat thread.
    public let participants: [ChatParticipant]

    // MARK: Initializers

    /// Initialize a `AddChatParticipantsRequest` structure.
    /// - Parameters:
    ///   - participants: Participants to add to a chat thread.
    public init(
        participants: [ChatParticipant]
    ) {
        self.participants = participants
    }

    // MARK: Codable

    enum CodingKeys: String, CodingKey {
        case participants = "participants"
    }

    /// Initialize a `AddChatParticipantsRequest` structure from decoder
    public init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)
        self.participants = try container.decode([ChatParticipant].self, forKey: .participants)
    }

    /// Encode a `AddChatParticipantsRequest` structure
    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(participants, forKey: .participants)
    }
}
