// --------------------------------------------------------------------------
// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
//
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// --------------------------------------------------------------------------

import AzureCore
import Foundation
// swiftlint:disable superfluous_disable_command
// swiftlint:disable identifier_name
// swiftlint:disable line_length
// swiftlint:disable cyclomatic_complexity

/// A user that got created with an Azure Communication Services resource.
public struct CommunicationUserIdentifierModel: Codable, Equatable {
    // MARK: Properties

    /// The Id of the communication user.
    public let id: String

    // MARK: Initializers

    /// Initialize a `CommunicationUserIdentifierModel` structure.
    /// - Parameters:
    ///   - id: The Id of the communication user.
    public init(
        id: String
    ) {
        self.id = id
    }

    // MARK: Codable

    enum CodingKeys: String, CodingKey {
        case id = "id"
    }

    /// Initialize a `CommunicationUserIdentifierModel` structure from decoder
    public init(from decoder: Decoder) throws {
        let container = try decoder.container(keyedBy: CodingKeys.self)
        self.id = try container.decode(String.self, forKey: .id)
    }

    /// Encode a `CommunicationUserIdentifierModel` structure
    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(id, forKey: .id)
    }
}
